> ## Documentation Index
> Fetch the complete documentation index at: https://docs.e2b.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Environment variables



## OpenAPI

````yaml /openapi-public.yaml get /envs
openapi: 3.1.0
info:
  title: E2B API
  version: 0.1.0
  description: >-
    Complete E2B developer API. Platform endpoints are served on api.e2b.app.
    Sandbox endpoints (envd) are served on the shared sandbox host
    (sandbox.e2b.app); target a specific sandbox with the E2b-Sandbox-Id and
    E2b-Sandbox-Port headers.
servers:
  - url: https://api.e2b.app
    description: E2B Platform API
security: []
tags:
  - name: Sandboxes
  - name: Templates
  - name: Tags
  - name: Volumes
  - name: Envd
  - name: Filesystem
  - name: Process
  - name: Teams
  - name: Secrets
  - name: Events
  - name: Webhooks
paths:
  /envs:
    servers:
      - url: https://sandbox.e2b.app
        description: Sandbox API (envd) - routes using sandbox ID and port headers
    get:
      tags:
        - Envd
      summary: Environment variables
      operationId: getEnvVars
      parameters:
        - name: E2b-Sandbox-Id
          in: header
          required: true
          description: >-
            Identifier of the target sandbox. Routes the request to that
            sandbox's envd over the shared sandbox host.
          schema:
            type: string
        - name: E2b-Sandbox-Port
          in: header
          required: true
          description: Port envd listens on inside the sandbox (default 49983).
          schema:
            type: integer
            default: 49983
          example: 49983
      responses:
        '200':
          description: Environment variables
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EnvVars'
        '400':
          description: The sandbox proxy rejects missing or invalid routing information.
          content:
            text/plain:
              schema:
                type: string
              examples:
                missingRoutingHeader:
                  summary: >-
                    The sandbox proxy rejects missing or invalid routing
                    information.
                  value: |
                    missing header
        '401':
          description: Sandbox access-token or signature authentication failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EnvdHTTPError'
              examples:
                sandboxAuthentication:
                  summary: Missing or invalid sandbox credentials
                  value:
                    code: 401
                    message: >-
                      unauthorized access, please provide a valid access token
                      or method signing if supported
        '500':
          description: The sandbox proxy encountered an unexpected routing error.
          content:
            text/plain:
              schema:
                type: string
              examples:
                routingFailure:
                  summary: The sandbox proxy encountered an unexpected routing error.
                  value: |
                    Unexpected error when routing request: invalid sandbox port
        '502':
          description: >-
            The sandbox proxy could not find the sandbox. Browser navigation may
            receive an HTML error page.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SandboxRoutingError'
              examples:
                sandboxNotFound:
                  value:
                    sandboxId: sandbox-id
                    message: The sandbox was not found
                    code: 502
            text/html:
              schema:
                type: string
      security:
        - SandboxAccessTokenAuth: []
components:
  schemas:
    EnvVars:
      additionalProperties:
        type: string
        description: Environment variables for the sandbox
      type: object
    EnvdHTTPError:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: integer
        message:
          type: string
      description: >-
        HTTP error from envd, with a numeric status code. Distinct from a
        Connect RPC error.
    SandboxRoutingError:
      type: object
      required:
        - sandboxId
        - message
        - code
      properties:
        sandboxId:
          type: string
        message:
          type: string
        code:
          type: integer
  securitySchemes:
    SandboxAccessTokenAuth:
      type: apiKey
      in: header
      name: X-Access-Token
      description: >-
        Sandbox access token (`envdAccessToken`) for authenticating requests to
        a running sandbox. Returned by: [POST
        /sandboxes](/api-reference/sandboxes/create-sandbox) (on create), [POST
        /sandboxes/{sandboxID}/connect](/api-reference/sandboxes/connect-to-sandbox)
        (on connect), [POST
        /sandboxes/{sandboxID}/resume](/api-reference/sandboxes/resume-sandbox)
        (on resume), and [GET
        /sandboxes/{sandboxID}](/api-reference/sandboxes/get-sandbox) (for
        running or paused sandboxes).

````